#ifndef APP_APP_DOC_H
#define APP_APP_DOC_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "document.h"

#include <memory>

/*************************************************

	AvP[V NX

**************************************************/

APP_BEGIN_NAMESPACE

class Core;
class Image;

class AppDoc : public Document
{
public:
	AppDoc();
	virtual ~AppDoc() throw();

	SIZE GetSize() const;
	virtual void OnNewDocument();
	virtual void OnCloseDocument();
	Core *GetCore();
	Image *GetImage();

	bool CanUndo() const;
	bool CanRedo() const;

	void Record();
	void Undo();
	void Redo();

	void OnChangeOptions();

protected:
	void UndoRedo(bool undo);
private:
	const std::auto_ptr<class AppDocMember> m_m;
};

APP_END_NAMESPACE

#endif
