#include "prefix.h"

#include "application.h"
#include "options.h"
#include "spray.h"
#include "tool.h"
#include "color.h"
#include "appframe.h"
#include "winman.h"
#include "registry.h"
#include "generalstatus.h"
#include "presetdir.h"
#include "file.h"
#include "string.h"
#include "exception.h"

#include <ctype.h>
#include <tchar.h>

/*************************************************

	AvP[V̏Ɛݒ̕ۑ

**************************************************/

APP_BEGIN_NAMESPACE

Application::Application() throw()
{
}

Application::~Application() throw()
{
	AppQuit_Options();
	AppQuit_Spray();
	AppQuit_Tool();
	AppQuit_Color();
	AppQuit_GeneralStatus();
	AppQuit_WinMan();
}

//ݒt@CƃWXĝǂɕۑ邩߂t@C̖O
static const _TCHAR * s_useRegistryFileName=_T("useregistry");

//
void Application::Initialize(HWND parentWindow)
{
	Registry registry;
	registry.OpenAppKey(true);

	ExchangeSettings(&registry);

	AppInit_Options(&registry);
	AppInit_Spray(&registry);
	AppInit_Tool(&registry);
	AppInit_Color(&registry);
	AppInit_GeneralStatus(&registry);
	AppInit_WinMan(&registry,parentWindow);
}

//ݒۑ
void Application::Save()
{
	Registry registry;
	registry.OpenAppKey(false);

	ExchangeSettings(&registry);

	AppSave_Options(&registry);
	AppSave_Spray(&registry);
	AppSave_Tool(&registry);
	AppSave_Color(&registry);
	AppSave_GeneralStatus(&registry);
	AppSave_WinMan(&registry);
}

//ݒۑ̃o[W
enum
{
	REGISTRY_VERSION_NONE,	//o[WԍȂ

	REGISTRY_VERSION_CURRENT	//݂̐ݒ̃o[W
};

//ݒۑ̃o[W̌
void Application::ExchangeSettings(Registry *registry)
{
	String useRegistryName;
	GetPresetDir(&useRegistryName);
	useRegistryName.Cat(s_useRegistryFileName);

	File file;
	if(file.Open(useRegistryName.Get())==ERROR_SUCCESS) {
		try {
			if(tolower(file.ReadChar())=='y') {
				registry->RegistryMode();
			}
		} catch(std::exception &) {}
		file.Close();
	}

	registry->OpenSubKey(NULL);
	int version=REGISTRY_VERSION_CURRENT;
	registry->Exchange(_T("RegistryVersion"),&version,REGISTRY_VERSION_NONE);
	if(version!=REGISTRY_VERSION_CURRENT) {
		registry->DefaultMode();
	}
}

APP_END_NAMESPACE
