#include "prefix.h"

#include "colortablecontrol.h"
#include "winmessage.h"
#include "image.h"
#include "verify.h"

#include <limits.h>

/*************************************************

	FIRg[̃NX

**************************************************/

APP_BEGIN_NAMESPACE

#define PIXELBYTES 3

class ColorTableMember
{
public:
	Image image;
	int level;
};

ColorTableControl::ColorTableControl()
:m_m(new ColorTableMember)
{
}

ColorTableControl::~ColorTableControl() throw()
{
}

//f̃oCg
#define PIXELBYTES 3

void ColorTableControl::AllocBuffer()
{
	RECT rect;
	GetClientRect(&rect);
	SIZE size;
	size.cx=Width(rect);
	size.cy=Height(rect);
	m_m->image.Create(size,PIXELBYTES);
	m_m->level=0;
	CreateImage(m_m->level);
}

LRESULT ColorTableControl::WindowProc(UINT msg,WPARAM wparam,LPARAM lparam)
{
	switch(msg) {
	case WM_LBUTTONDOWN:
		OnLButtonDown((short)LOWORD(lparam),(short)HIWORD(lparam));
		break;

	case WM_GETDLGCODE:
		return OnGetDlgCode();

	case APP_WM_REFLECT_DRAWITEM:
		OnDrawItem((DRAWITEMSTRUCT*)wparam);
		break;

	default:
		return Window::WindowProc(msg,wparam,lparam);
	}
	return 0;
}

//\
void ColorTableControl::OnDrawItem(DRAWITEMSTRUCT *drawItemStruct)
{
	HDC hdc(drawItemStruct->hDC);
	RECT rect(drawItemStruct->rcItem);

	VERIFY(::SetDIBitsToDevice(hdc
		,rect.left,rect.top
		,m_m->image.Width(),m_m->image.Height()
		,0,0
		,0,m_m->image.Height()
		,m_m->image.Get()
		,m_m->image.BitmapInfo()
		,DIB_RGB_COLORS));
}

//󂯕tL[͂̎
UINT ColorTableControl::OnGetDlgCode() const
{
	return 0;
}

//{^
void ColorTableControl::OnLButtonDown(int x,int y)
{
	int color=0;
	const unsigned char *buffer=m_m->image.GetPixel(x,y);

	for(int c=0;c<PIXELBYTES;++c) {
		color<<=CHAR_BIT;
		color+=buffer[c];
	}

	::PostMessage(GetParent(),APP_WM_CONTROL
		,MAKELONG(GetID(),COLORTABLE_SELECT),color);
}

void ColorTableControl::OnDestroy()
{
	UnsubclassWindow();
	Window::OnDestroy();
}

//ʂɂȂFo
void ColorTableControl::SetLevel(int level)
{
	m_m->level=level;
	CreateImage(level);
	InvalidateRect(NULL);
}

//e[ủ摜̍XV
void ColorTableControl::CreateImage(int level)
{
	unsigned char *buffer=m_m->image.GetW();
	const int width=m_m->image.Width();
	const int height=m_m->image.Height();
	const int padBytes=m_m->image.PadBytes();
	FOR(int y=0;y<height;++y) {
		FOR(int x=0;x<width;++x) {
			buffer[0]=255*y/(height-1);
			buffer[1]=255*x/(width-1);
			buffer[2]=level;
			buffer+=3;
		}
		FOR(int p=0;p<padBytes;++p) {
			*buffer=0;
			++buffer;
		}
	}

}

APP_END_NAMESPACE