#include "prefix.h"

#include "command.h"
#include "toolbar.h"
#include "verify.h"

#include <windows.h>
#include <assert.h>

/*************************************************

	j[{^̕\XV

**************************************************/

APP_BEGIN_NAMESPACE

enum
{
	TYPE_NONE,	//܂ݒ肳ĂȂ
	TYPE_MENU,	//j[
	TYPE_TOOLBAR,	//c[o[̃{^
};


Command::Command()
	:m_type(TYPE_NONE)
{

}

Command::~Command()
{

}

//j[ݒ
void Command::SetMenu(HMENU menu,int index)
{
	m_type=TYPE_MENU;
	m_menu.menu=menu;
	m_menu.index=index;
}

//c[o[̃{^ݒ
void Command::SetToolBar(HWND toolBar,int id)
{
	m_type=TYPE_TOOLBAR;
	m_toolBar.toolBar=toolBar;
	m_toolBar.id=id;
}

//`FbNĂԂ̕ύX
void Command::SetCheck(bool isChecked)
{
	switch(m_type) {
	case TYPE_MENU:
		SetCheckMenu(m_menu.menu,m_menu.index,isChecked);
		break;

	case TYPE_TOOLBAR:
		SetCheckToolBar(m_toolBar.toolBar,m_toolBar.id,isChecked);
		break;

	default:
		assert(false);
		break;
	}
}

//j[̃`FbNĂԂ̕ύX
void Command::SetCheckMenu(HMENU menu,int index,bool isChecked)
{
	UINT check=MF_BYPOSITION;
	if(isChecked) {
		check|=MF_CHECKED;
	} else {
		check|=MF_UNCHECKED;
	}
	VERIFY(::CheckMenuItem(menu,index,check)!=0xffffffff);
}

//c[o[̃`FbNĂԂ̕ύX
void Command::SetCheckToolBar(HWND toolBar,int id,bool isChecked)
{
	ToolBarButtonCheck(toolBar,id,isChecked);
}

//p\ȏԂ̕ύX
void Command::SetEnable(bool isEnabled)
{
	switch(m_type) {
	case TYPE_MENU:
		SetEnableMenu(m_menu.menu,m_menu.index,isEnabled);
		break;

	case TYPE_TOOLBAR:
		SetEnableToolBar(m_toolBar.toolBar,m_toolBar.id,isEnabled);
		break;

	default:
		assert(false);
		break;
	}
}

//j[̗p\ȏԂ̕ύX
void Command::SetEnableMenu(HMENU menu,int index,bool isEnabled)
{
	UINT enable=MF_BYPOSITION;
	if(isEnabled) {
		enable|=MF_ENABLED;
	} else {
		enable|=MF_GRAYED;
	}
	VERIFY(::EnableMenuItem(menu,index,enable)!=0xffffffff);
}

//c[o[̗p\ȏԂ̕ύX
void Command::SetEnableToolBar(HWND toolBar,int id,bool isEnabled)
{
	ToolBarButtonEnable(toolBar,id,isEnabled);
}

APP_END_NAMESPACE
