#include "prefix.h"

#include "curcolorcontrol.h"
#include "color.h"
#include "dc.h"
#include "gdiobject.h"
#include "winmessage.h"

/*************************************************

	݂̐F̃Rg[̃NX

**************************************************/

APP_BEGIN_NAMESPACE

CurrentColorControl::CurrentColorControl()
{
	
}

CurrentColorControl::~CurrentColorControl() throw()
{
}

LRESULT CurrentColorControl::WindowProc(UINT msg,WPARAM wparam,LPARAM lparam)
{
	switch(msg) {
	case WM_LBUTTONDOWN:
		OnLButtonDown((short)LOWORD(lparam),(short)HIWORD(lparam));
		break;

	case WM_GETDLGCODE:
		return OnGetDlgCode();

	case APP_WM_REFLECT_DRAWITEM:
		OnDrawItem((DRAWITEMSTRUCT*)wparam);
		break;

	default:
		return Window::WindowProc(msg,wparam,lparam);
	}
	return 0;
}

//dȂ 1/n
#define OVERLAP 3

//\
void CurrentColorControl::OnDrawItem(DRAWITEMSTRUCT *drawItemStruct)
{
	if(drawItemStruct->itemState & ODS_DISABLED) {
		return;
	}

	DrawItemDC dc(drawItemStruct->hDC);

	const COLOR_INFO *colorInfo=GetColorInfo();

	RECT backRect;
	BackRect(&backRect);

	GdiObject selectPen(::CreatePen(PS_SOLID,2,0xffffff));
	GdiObject deselectPen(BLACK_PEN);

	if(colorInfo->isForeSelected) {
		dc.SelectObject(&deselectPen);
	} else {
		dc.SelectObject(&selectPen);
	} 
	HBRUSH hBackBrush(::CreateSolidBrush(colorInfo->color[BACKCOLOR]));
	GdiObject backBrush(hBackBrush);
	dc.SelectObject(&backBrush);

	::Rectangle(dc.Get(),backRect.left,backRect.top,backRect.right,backRect.bottom);

	RECT foreRect;
	ForeRect(&foreRect);

	if(colorInfo->isForeSelected) {
		dc.SelectObject(&selectPen);
	} else {
		dc.SelectObject(&deselectPen);
	}
	HBRUSH hForeBrush(::CreateSolidBrush(colorInfo->color[FORECOLOR]));
	GdiObject foreBrush(hForeBrush);
	dc.SelectObject(&foreBrush);
	::Rectangle(dc.Get(),foreRect.left,foreRect.top,foreRect.right,foreRect.bottom);
}

//OiF̋`
void CurrentColorControl::ForeRect(RECT *rect) const
{
	GetClientRect(rect);
	rect->right-=Width(*rect)/OVERLAP;
	rect->bottom-=Height(*rect)/OVERLAP;
}

//wiF̋`
void CurrentColorControl::BackRect(RECT *rect) const
{
	GetClientRect(rect);
	rect->left+=Width(*rect)/OVERLAP;
	rect->top+=Height(*rect)/OVERLAP;
}

//󂯕tL[͂̎
UINT CurrentColorControl::OnGetDlgCode() const
{
	return 0;
}

//{^
void CurrentColorControl::OnLButtonDown(int x,int y)
{
	POINT point;
	point.x=x;
	point.y=y;

	COLOR_INFO colorInfo;
	GetColorInfo(&colorInfo);

	RECT foreRect;
	ForeRect(&foreRect);
	if(::PtInRect(&foreRect,point)) {
		colorInfo.isForeSelected=true;
	} else {
		RECT backRect;
		BackRect(&backRect);
		if(::PtInRect(&backRect,point)) {
			colorInfo.isForeSelected=false;
		}
	}
	SetColorInfo(colorInfo);
	InvalidateRect();
}

void CurrentColorControl::OnDestroy()
{
	UnsubclassWindow();
	Window::OnDestroy();
}

APP_END_NAMESPACE