#ifndef APP_DELAY_COMPRESS_H
#define APP_DELAY_COMPRESS_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "delay.h"

#include <memory>

/*************************************************

	f[^\̒x k

**************************************************/

APP_BEGIN_NAMESPACE

class DelayCompress : public Delay
{
public:
	DelayCompress(std::auto_ptr<Delay> delay,bool doesCompress);
	DelayCompress(Delay *delay,bool doesCompress);
	virtual ~DelayCompress() throw();

	virtual bool IsEOF() const;

	virtual int PoolBytes() const;
	virtual const unsigned char *Get();
	virtual void Advance(int bytes);

	virtual int Read(void *data,int bytes);
	void Read(UCharBuffer *buffer);
private:
	void Initialize(bool doesCompress);

	DelayCompress(const DelayCompress &source);
	const DelayCompress &operator=(const DelayCompress &source);

	const std::auto_ptr<class DelayCompressMember> m_m;
};

APP_END_NAMESPACE

#endif
