#include "prefix.h"

#include "exception.h"

/*************************************************

	ONX

**************************************************/

APP_BEGIN_NAMESPACE

Exception::Exception(int errorCode,DWORD apiErrorCode) throw()
	:m_errorCode(errorCode)
	,m_apiErrorCode(apiErrorCode)
{
}

Exception::Exception(const Exception &source) throw()
	:m_errorCode(source.GetErrorCode())
	,m_apiErrorCode(source.GetAPIErrorCode())
{
}

const Exception &Exception::operator=(const Exception &source) throw()
{
	m_errorCode=source.GetErrorCode();
	m_apiErrorCode=source.GetAPIErrorCode();
	return *this;
}

Exception::~Exception() throw()
{
}

const char *Exception::what() const throw()
{
	return "Application Error";
}

//G[ԍ
int Exception::GetErrorCode() const throw()
{
	return m_errorCode;
}

//WinAPĨG[ԍ
DWORD Exception::GetAPIErrorCode() const throw()
{
	return m_apiErrorCode;
}

APP_END_NAMESPACE
