#include "prefix.h"

#include "fileexception.h"

#include <string.h>

/*************************************************

	ONX

**************************************************/

APP_BEGIN_NAMESPACE

FileException::FileException() throw()
{
}

FileException::FileException(int errorCode,const _TCHAR * filename) throw()
	:Exception(errorCode)
{
	CopyFileName(filename);
}

//APĨG[
FileException::FileException(int errorCode,DWORD apiErrorCode,const _TCHAR * filename) throw()
	:Exception(errorCode,apiErrorCode)
{
	CopyFileName(filename);
}

FileException::FileException(const FileException &source) throw()
	:Exception(source)
{
	CopyFileName(source.GetFileName());
}

const FileException &FileException::operator=(const FileException &source) throw()
{
	*this=source;
	CopyFileName(source.GetFileName());
	return *this;
}

FileException::~FileException() throw()
{
}

//t@Cʂ
void FileException::CopyFileName(const _TCHAR * filename) throw()
{
	memset(m_filename,0,_MAX_PATH*sizeof(_TCHAR));
	if(filename!=NULL) {
		_tcsncpy(m_filename,filename,_MAX_PATH-1);
	}
}

const char *FileException::what() const throw()
{
	return "Application File Error";
}

//G[oƂ̃t@C
const _TCHAR * FileException::GetFileName() const throw()
{
	return m_filename;
}


APP_END_NAMESPACE
