#ifndef APP_FRAME_H
#define APP_FRAME_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "window.h"

#include <memory>
#include <windows.h>

/*************************************************

	OgEBhENX

**************************************************/

APP_BEGIN_NAMESPACE

enum	//qEBhEID
{
	ID_CHILD_WINDOW_FIRST=1000,

	ID_TOOLBAR=ID_CHILD_WINDOW_FIRST,
	ID_STATUSBAR,

	ID_CHILD_WINDOW_LAST,

	ID_VIEW
};

class View;
class Command;
struct ToolbarButton;

class Frame : public Window
{
public:
	Frame();
	virtual ~Frame() throw();

	virtual void Create(const RECT &rect,HWND parentWindow);
	virtual LRESULT WindowProc(UINT msg,WPARAM wparam,LPARAM lparam);
	View *GetView();
	void AttachView(View *view);
	void SetStatusText(int textID);
	bool OnIdle();
protected:
	virtual void OnNcDestroy();
	void OnSize(UINT type,int width,int height);
	virtual void OnCommand(int id,int notifyCode,HWND hwnd);
	virtual void OnUpdateCommand(int id,Command *command);
	virtual void OnClose();
	void OnNotify(int id,NMHDR *nmhdr);
	void OnInitMenuPopup(HMENU hmenu,int,bool isSystemMenu);
	void OnUpdateWindow();

	void OnMenuSelect(int item,UINT flag,HMENU menu);
	void OnKeyDown(WPARAM wparam,LPARAM lparam);
	void OnKeyUp(WPARAM wparam,LPARAM lparam);
	void OnActivateApp(WPARAM wparam,LPARAM lparam);

	virtual void AdjustChildWindows();
private:
	//`Ȃ
	Frame(const Frame &source);
	const Frame &operator=(const Frame &source);

	std::auto_ptr<View> m_view;	//LĂr[EBhEIuWFNg
	int m_lastStatusTextID;	//Ōɕ\Xe[^Xo[̕
};

APP_END_NAMESPACE

#endif

