#include "prefix.h"

#include "generalstatus.h"
#include "registry.h"
#include "string.h"
#include "fpoint.h"
#include "cellsize.h"

#include <tchar.h>

/*************************************************

	Ŝ̏

**************************************************/

APP_BEGIN_NAMESPACE

static GENERAL_STATUS s_status;

static void ExchangeSettings(Registry *registry);

//AvP[V̍ŏ̏
void AppInit_GeneralStatus(Registry *registry)
{
	ExchangeSettings(registry);
}

//ݒ̕ۑ
void AppSave_GeneralStatus(Registry *registry)
{
	ExchangeSettings(registry);
}

//AvP[VI
void AppQuit_GeneralStatus() throw()
{
}

//Pʂ̏d͂ݒ
void SetCellGravity()
{
	s_status.cellGravity.x=s_status.gravity.x/CELL_SIZE;
	s_status.cellGravity.y=s_status.gravity.y/CELL_SIZE;
}

//ݒ̌
static void ExchangeSettings(Registry *registry)
{
	registry->OpenSubKey(NULL);
	registry->Exchange(_T("GravityType"),&(s_status.gravityType),GRAVITY_PARALLEL);
	registry->Exchange(_T("GravityX"),&(s_status.gravity.x),0.0);
	registry->Exchange(_T("GravityY"),&(s_status.gravity.y),0.5);
	registry->Exchange(_T("Lively"),&s_status.lively,0.5);

	if(registry->IsReading()) {
		if(s_status.gravityType<0 || GRAVITY_COUNT<=s_status.gravityType) {
			s_status.gravityType=GRAVITY_PARALLEL;
		}
		if(s_status.lively<0) {
			s_status.lively=0;
		}
		if(s_status.lively>1.0) {
			s_status.lively=1.0;
		}
		SetCellGravity();
	}
}

//Ŝ̏Ԃ𓾂
const GENERAL_STATUS *GetGeneralStatus(GENERAL_STATUS *generalStatus)
{
	if(generalStatus!=NULL) {
		*generalStatus=s_status;
	}
	return &s_status;
}

//Ŝ̏Ԃݒ
void SetGeneralStatus(const GENERAL_STATUS &generalStatus)
{
	assert(0<=generalStatus.gravityType && generalStatus.gravityType<GRAVITY_COUNT); 
	assert(0<=generalStatus.lively);

	s_status=generalStatus;
	SetCellGravity();
}

APP_END_NAMESPACE
