#include "prefix.h"

#include "gravitydetail.h"
#include "updatecontrol.h"
#include "cellsize.h"
#include "spray.h"
#include "spraystyle.h"
#include "volumecontrol.h"

#include "resdialog.h"

/*************************************************

	͂̏ڍאݒ

**************************************************/

APP_BEGIN_NAMESPACE

class GravityDetailMember
{
public:
	VolumeControl effectiveAreaControl;
	double gravityArea;	//L͈
};

GravityDetail::GravityDetail()
:LimitDialog(IDD_GRAVITY_DETAIL)
,m_m(new GravityDetailMember)
{
}

GravityDetail::~GravityDetail() throw()
{

}

//_CAȌ
void GravityDetail::OnInitDialog()
{
	LimitDialog::OnInitDialog();

	m_m->effectiveAreaControl.SubclassDialogItem(IDC_GRAVITY_AREA,this);
	m_m->effectiveAreaControl.SetRange(
		SprayStyleType(SPRAYSTYLE_GRAVITY_AREA)->lowerLimit
		,SprayStyleType(SPRAYSTYLE_GRAVITY_AREA)->upperLimit);
	m_m->effectiveAreaControl.SetShowMode(VOLUME_SHOW_FLOAT_PIXEL);

	const SPRAYSTYLE *sprayStyle=GetSprayStyle();
	m_m->gravityArea=sprayStyle->gravityArea;
}

//Rg[ƕϐ̃f[^\̍XV
void GravityDetail::DataExchange(UpdateControl *updater)
{
	LimitDialog::DataExchange(updater);

	updater->Volume(IDC_GRAVITY_AREA,&m_m->gravityArea);
}

//{^
bool GravityDetail::Apply()
{
	if(!LimitDialog::Apply()) {
		return false;
	}

	SPRAYSTYLE sprayStyle;
	GetSprayStyle(&sprayStyle);
	sprayStyle.gravityArea=m_m->gravityArea;
	SetSprayStyle(sprayStyle);
	return true;
}

APP_END_NAMESPACE
