#ifndef APP_HISTORY_H
#define APP_HISTORY_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"

#include <memory>

/*************************************************

	

**************************************************/

APP_BEGIN_NAMESPACE

class HistoryItem;

class History
{
public:
	History() throw();
	~History() throw();

	bool BeginWrite();
	void EndWrite();
	void CancelWrite() throw();
	void PushItem(HistoryItem *item);

	void BeginRead(bool undo);
	void EndRead();
	void CancelRead() throw();
	const HistoryItem *NextItem();

	bool CanUndo() const;
	bool CanRedo() const;

	void Destroy();

	int Count() const;

	void OnChangeOptions();
protected:
	//`Ȃ
	History(const History &source);
	const History &operator=(const History &source);

	const std::auto_ptr<class HistoryMember> m_m;
};

APP_END_NAMESPACE

#endif

