#ifndef APP_HISTORY_ITEM_H
#define APP_HISTORY_ITEM_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"

#include <memory>

/*************************************************

	̍

**************************************************/

APP_BEGIN_NAMESPACE

class Delay;

class HistoryItem
{
public:
	HistoryItem() throw();
	~HistoryItem() throw();

	void SetKey(int key,int subKey);
	int GetKey() const;
	int GetSubKey() const;

	int Size() const;

	int ReadInteger(int *pointer) const;
	double ReadDouble(int *pointer) const;
	void ReadData(int *pointer,std::auto_ptr<Delay> *delay) const;

	void WriteInteger(int *pointer,int value);
	void WriteDouble(int *pointer,double value);
	void WriteData(int *pointer,Delay *delay);
	
	void Shorten(int size);
protected:
	void ReadTag(int *pointer,int tag,void *data,int size) const;
	void WriteTag(int *pointer,int tag,const void *data,int size);
private:
	//`Ȃ
	HistoryItem(const HistoryItem &source);
	const HistoryItem &operator=(const HistoryItem &source);

	const std::auto_ptr<class HistoryItemMember> m_m;
};

APP_END_NAMESPACE

#endif
