#include "prefix.h"

#include "historyreader.h"
#include "history.h"
#include "historyitem.h"

/*************************************************

	̓ǂ݂Ƃ

**************************************************/

APP_BEGIN_NAMESPACE

class HistoryReaderMember
{
public:
	HistoryReaderMember(History *history)
		:history(history)
		,item(NULL)
		,pointer(0)
		,isReading(false)
	{
	}
	~HistoryReaderMember()
	{
	}

	History *history;	//̃|C^
	const HistoryItem *item;	//̍
	int pointer;	//̍ڂ̌ݓǂłʒu
	bool isReading;
	bool undo;
};

HistoryReader::HistoryReader(History *history)
:m_m(new HistoryReaderMember(history))
{
	assert(history!=NULL);
}

HistoryReader::~HistoryReader() throw()
{
	if(m_m->isReading) {
		m_m->history->CancelRead();
	}
}

//ǂݎ̊Jn
void HistoryReader::BeginRead(bool undo)
{
	m_m->undo=undo;
	m_m->history->BeginRead(undo);
	m_m->item=m_m->history->NextItem();
	m_m->isReading=true;
}

int HistoryReader::GetKey() const
{
	assert(m_m->item!=NULL);
	return m_m->item->GetKey();
}

int HistoryReader::GetSubKey() const
{
	assert(m_m->item!=NULL);
	return m_m->item->GetSubKey();
}

bool HistoryReader::IsEnd() const
{
	return m_m->item==NULL;
}

void HistoryReader::Next()
{
	m_m->item=m_m->history->NextItem();
	m_m->pointer=0;
}

void HistoryReader::EndRead()
{
	m_m->history->EndRead();
	m_m->isReading=false;
}

//ǂ
int HistoryReader::ReadInteger()
{
	assert(m_m->item!=NULL);
	return m_m->item->ReadInteger(&(m_m->pointer));
}

//ǂ
double HistoryReader::ReadDouble()
{
	assert(m_m->item!=NULL);
	return m_m->item->ReadDouble(&(m_m->pointer));
}

void HistoryReader::ReadData(std::auto_ptr<Delay> *delay)
{
	assert(m_m->item!=NULL);
	m_m->item->ReadData(&(m_m->pointer),delay);
}

APP_END_NAMESPACE
