#include "prefix.h"

#include "historywriter.h"
#include "history.h"
#include "historyitem.h"
#include "delay.h"

/*************************************************

	̓o^

**************************************************/

APP_BEGIN_NAMESPACE

class HistoryWriterMember
{
public:
	HistoryWriterMember(History *history)
		:history(history)
		,item(NULL)
		,isWritting(false)
		,pointer(0)
	{
	}
	~HistoryWriterMember()
	{
	}

	History *history;	//̃|C^
	std::auto_ptr<HistoryItem> item;	//̍
	int pointer;	//̍ڂɌݏĂʒu

	bool isWritting;	//L^ĂŒ
};

HistoryWriter::HistoryWriter(History *history)
:m_m(new HistoryWriterMember(history))
{
}

HistoryWriter::~HistoryWriter() throw()
{
	if(m_m->isWritting) {
		m_m->history->CancelWrite();
	}
}

//Ȃn߂
bool HistoryWriter::BeginWrite()
{
	if(!m_m->history->BeginWrite()) {
		return false;
	}
	m_m->isWritting=true;

	APP_RESET_AUTO_PTR(m_m->item,HistoryItem,new HistoryItem);
	return true;
}

//ȂI
void HistoryWriter::EndWrite()
{
	m_m->history->EndWrite();
	m_m->isWritting=false;
}

//ڂo^
void HistoryWriter::Push(int key,int subKey)
{
	if(m_m->item->Size()!=0) {
		m_m->item->SetKey(key,subKey);
		m_m->item->Shorten(m_m->pointer);
		m_m->history->PushItem(m_m->item.release());
		APP_RESET_AUTO_PTR(m_m->item,HistoryItem,new HistoryItem);
		m_m->pointer=0;
	}
}

//
void HistoryWriter::WriteInteger(int value)
{
	assert(m_m->item.get()!=NULL);
	m_m->item->WriteInteger(&m_m->pointer,value);
}

//
void HistoryWriter::WriteDouble(double value)
{
	assert(m_m->item.get()!=NULL);
	m_m->item->WriteDouble(&m_m->pointer,value);
}

//f[^
void HistoryWriter::WriteData(Delay *delay)
{
	assert(m_m->item.get()!=NULL);
	m_m->item->WriteData(&m_m->pointer,delay);
}

APP_END_NAMESPACE
