#ifndef APP_IMAGE_H
#define APP_IMAGE_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"

#include <windows.h>

/*************************************************

	摜obt@

**************************************************/

APP_BEGIN_NAMESPACE

struct BITMAPINFO_FIELDS
{
	BITMAPINFOHEADER bmiHeader;
	DWORD bitFields[3];
};

class Image
{
public:
	Image();
	Image(const Image &source);
	~Image() throw();
	const Image &operator=(const Image &source);
	void Free() throw();

	void Create(SIZE size,int pixelBytes);
	void Resize(SIZE size,int pixelBytes);

	void Dup(const Image &source);

	void Clear();

	SIZE Size() const;
	int RowDataBytes() const;
	int Width() const;
	int Height() const;
	int TotalBytes() const;
	int RowBytes() const;
	int PadBytes() const;
	int PixelBytes() const;
	const BITMAPINFO *BitmapInfo() const;
	unsigned char *GetW();
	const unsigned char *Get() const;
	unsigned char *GetRowW(int y);
	const unsigned char *GetRow(int y) const;
	unsigned char *GetPixelW(int x,int y);
	const unsigned char *GetPixel(int x,int y) const;
private:
	const std::auto_ptr<class ImageMember> m_m;
};

APP_END_NAMESPACE

#endif
