#include "prefix.h"

#include "main.h"
#include "application.h"
#include "winman.h"
#include "showerror.h"
#include "error.h"
#include "verify.h"

#include "resmain.h"

#include <windows.h>
#include <commctrl.h>
#include <memory>
#include <new.h>
#include <exception>

/*************************************************

	Gg[|Cg

**************************************************/

APP_BEGIN_NAMESPACE

static HINSTANCE s_hInstance;

//W[̃nh
HINSTANCE GetInstance()
{
	return s_hInstance;
}

#ifdef _MSC_VER
//new̗O
int App_new_handler(size_t size)
{
	throw std::bad_alloc();
	return 0;
}
#endif

#ifdef APP_STANDALONE

//P̂Ŏs
extern "C" 
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE,LPSTR,int)
{
#ifdef _MSC_VER
	::_set_new_handler(App_new_handler);
#endif

	s_hInstance=hInstance;

	return MainLoop(NULL);
}

#else //APP_STANDALONE

//vOCƂĎs
extern "C"
BOOL CALLBACK DllMain(HINSTANCE hModule,DWORD reason,void *)
{
#ifdef _MSC_VER
	if(reason==DLL_PROCESS_ATTACH) {
		::_set_new_handler(App_new_handler);
	}
#endif
	s_hInstance=hModule;
	return TRUE;
}

#endif	//APP_STANDALONE

static bool OnIdle();

//bZ[W
LRESULT MainLoop(HWND parentWindow)
{
	::InitCommonControls();

	Application application;

	try {
		application.Initialize(parentWindow);
	} catch(std::exception &e) {
		if(GetFrameHWND()!=NULL) {
			::DestroyWindow(GetFrameHWND());
		}
		ShowError(NULL,e);
		return 0;
	}

	HACCEL haccel=::LoadAccelerators(GetInstance()
		,MAKEINTRESOURCE(IDR_MAIN));
	assert(haccel!=NULL);

	MSG msg;
	bool doesIdle=true;
	for(;;) {
		if(doesIdle) {
			if(!::PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
				doesIdle=OnIdle();
				continue;
			}
			if(msg.message==WM_QUIT) break;
		} else {
			if(!::GetMessage(&msg,NULL,0,0)) break;
			doesIdle=true;
		}

		if(msg.message==WM_SYSKEYDOWN) {
			HWND frame=GetFrameHWND();
			if(::IsWindowEnabled(frame)) {
				::SetActiveWindow(frame);
			}
		}
		if(!::TranslateAccelerator(GetFrameHWND()
			,haccel,&msg)) {
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
	}

	if(GetFrameHWND()!=NULL) {
		::DestroyWindow(GetFrameHWND());
	}

	try {
		application.Save();
	} catch(std::exception &e) {
		ShowError(NULL,e);
	}

	return msg.wParam;
}

//ĂȂƂ
bool OnIdle()
{
	bool result=false;
	try {
		result=OnIdle_WinMan();
	} catch(std::exception &e) {
		ShowError(NULL,e);
	}
	return result;
}

APP_END_NAMESPACE
