#include "prefix.h"

#include "options.h"
#include "registry.h"

#include <tchar.h>

/*************************************************

	s̃AvP[V̐ݒ

**************************************************/

APP_BEGIN_NAMESPACE

static OPTIONS s_options;

static void ExchangeSettings(Registry *registry);

//ݒ
void AppInit_Options(Registry *registry)
{
	ExchangeSettings(registry);
}

//ݒۑ
void AppSave_Options(Registry *registry)
{
	ExchangeSettings(registry);
}

//I
void AppQuit_Options() throw()
{
}

static void ExchangeSettings(Registry *registry)
{
	registry->OpenSubKey(NULL);
	registry->Exchange(_T("TurnInterval")
		,&(s_options.turnInterval),40);
	registry->Exchange(_T("DisplayingInterval")
		,&(s_options.displayingInterval),1);
	registry->Exchange(_T("ViewMat")
		,&(s_options.viewMat),MAT_CHECKER);
	registry->Exchange(_T("HistoryMax")
		,&(s_options.historyMax),100);

	if(registry->IsReading()) {
		if(s_options.turnInterval<1) {
			s_options.turnInterval=1;
		}
		if(s_options.displayingInterval<1) {
			s_options.displayingInterval=1;
		}
		if(s_options.historyMax<0) {
			s_options.historyMax=0;
		}
	}
}

//IvV̒l𓾂
const OPTIONS *GetOptions(OPTIONS *options)
{
	if(options!=NULL) {
		*options=s_options;
	}
	return &s_options;
}

//IvVݒ
void SetOptions(const OPTIONS &options)
{
	assert(0<options.turnInterval);
	assert(0<options.displayingInterval);
	assert(0<=options.viewMat && options.viewMat<MAT_COUNT);
	assert(0<=options.historyMax);
	s_options=options;
}

APP_END_NAMESPACE
