#include "prefix.h"

#include "optionsdialog.h"
#include "updatecontrol.h"
#include "options.h"
#include "winman.h"
#include "winmessage.h"
#include "showerror.h"

#include "resdialog.h"
#include "resstring.h"

#include <windows.h>

/*************************************************

	s̃AvP[V̐ݒ̃_CAO

**************************************************/

APP_BEGIN_NAMESPACE

OptionsDialog::OptionsDialog()
:Dialog(IDD_OPTIONS)
,m_isModified(false)
{

}

OptionsDialog::~OptionsDialog() throw()
{

}

//
void OptionsDialog::OnInitDialog()
{
	Dialog::OnInitDialog();

	const OPTIONS *options=GetOptions();
	m_turnInterval=options->turnInterval;
	m_displayingInterval=options->displayingInterval;
	m_historyMax=options->historyMax;

	m_isModified=false;
}

//R}h
void OptionsDialog::OnCommand(int id,int notifyCode,HWND hwnd)
{
	switch(id) {
	case IDC_TURN_INTERVAL:
	case IDC_DISPLAYING_INTERVAL:
	case IDC_HISTORY_MAX:
		m_isModified=true;
		break;

	default:
		Dialog::OnCommand(id,notifyCode,hwnd);
		break;
	}
}

//ڂɓ͂ꂽl
bool OptionsDialog::Apply()
{
	if(!m_isModified) return true;

	if(m_turnInterval<=0) {
		ShowError(GetHWND(),IDS_ERR_RANGE_TURN_INTERVAL,1);
		return false;
	}
	if(m_displayingInterval<=0) {
		ShowError(GetHWND(),IDS_ERR_RANGE_DISPLAYING_INTERVAL,1);
		return false;
	}
	if(m_historyMax<0) {
		ShowError(GetHWND(),IDS_ERR_RANGE_HISTORY_MAX,0);
	}

	OPTIONS options;
	GetOptions(&options);
	options.turnInterval=m_turnInterval;
	options.displayingInterval=m_displayingInterval;
	options.historyMax=m_historyMax;
	SetOptions(options);
	SendAllWindowsMessage(APP_WM_CHANGE_OPTIONS,0,0);
	return true;
}

//Rg[ƕϐ̃f[^\̍XV
void OptionsDialog::DataExchange(UpdateControl *updater)
{
	updater->Edit(IDC_TURN_INTERVAL,&m_turnInterval);
	updater->Edit(IDC_DISPLAYING_INTERVAL,&m_displayingInterval);
	updater->Edit(IDC_HISTORY_MAX,&m_historyMax);

	updater->Enable(IDC_APPLY,m_isModified);
}

APP_END_NAMESPACE
