#include "prefix.h"

#include "panel.h"
#include "registry.h"
#include "winmessage.h"

/*************************************************

	pl

**************************************************/

APP_BEGIN_NAMESPACE

Panel::Panel(const _TCHAR * registerKey,int id)
:Dialog(id)
,m_registerKey(registerKey)
{

}

Panel::~Panel() throw()
{

}

//AvP[V̏
void Panel::AppInit(Registry *registry)
{
	ExchangeSettings(registry);
}

//ݒ̕ۑ
void Panel::AppSave(Registry *registry)
{
	ExchangeSettings(registry);
}

//AvP[V̏I
void Panel::AppQuit() throw()
{
}

//WXg[Ȃǂ̏ݒƂ̒ľ
void Panel::ExchangeSettings(Registry *registry)
{
	registry->OpenSubKey(m_registerKey);

	RECT nullRect={0,0,0,0};
	registry->Exchange(_T("Window"),&(m_initWindowRect),nullRect);

	registry->Exchange(_T("Show"),&m_initShow,true);
}

LRESULT Panel::WindowProc(UINT msg,WPARAM wparam,LPARAM lparam)
{
	switch(msg) {
	case WM_SHOWWINDOW:
		OnShowWindow(wparam!=FALSE,(int)lparam);
		break;

	case WM_CLOSE:
		OnClose();
		break;

	default:
		return Dialog::WindowProc(msg,wparam,lparam);
	}
	return TRUE;
}


void Panel::Create(HWND parentWindow)
{
	Dialog::Create(parentWindow);

	UINT flags=SWP_NOOWNERZORDER|SWP_NOZORDER|SWP_NOACTIVATE
			 |SWP_NOREDRAW|SWP_NOSIZE;
	if(Width(m_initWindowRect)==0) {
		flags|=SWP_NOMOVE;
	}

//vύX EBhȆ傫ςpl̏ꍇSWP_NOSIZEgȂ
	
	SetWindowPos(NULL
		,m_initWindowRect.left,m_initWindowRect.top
		,Width(m_initWindowRect),Height(m_initWindowRect)
		,flags);

	int showMode;
	if(m_initShow) {
		showMode=SW_SHOW;
	} else {
		showMode=SW_HIDE;
	}
	ShowWindow(showMode);
}

void Panel::OnShowWindow(bool show,int status)
{
	if(status==0) {
		m_initShow=show;
	}
}

void Panel::OnClose()
{
	ShowWindow(SW_HIDE);
	::SendMessage(GetParent(),APP_WM_UPDATE_WINDOW,0,0);
}

void Panel::OnDestroy()
{
	HWND parentWindow=GetParent();
	GetWindowRect(&m_initWindowRect);
	Dialog::OnDestroy();
	::PostMessage(parentWindow,APP_WM_UPDATE_WINDOW,0,0);
}

APP_END_NAMESPACE



