#ifndef APP_PARTICLE_INFO_LIST_H
#define APP_PARTICLE_INFO_LIST_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "buffer.h"

/*************************************************

	q̑̔z

**************************************************/

APP_BEGIN_NAMESPACE

struct PARTICLE_INFO;
struct SEARCHRESULT;
struct PARTICLE_INFO_ITEM;

class ParticleInfoList
{
public:
	ParticleInfoList();
	~ParticleInfoList() throw();

	int AddType(const PARTICLE_INFO &particleInfo);
	void IncreaseReferenceCount(int index);
	void DecreaseReferenceCount(int index);
	void Clean(int index);
	const PARTICLE_INFO *Get(int index);
	void Free();
	bool IsEmpty() const;
protected:
	void Delete(int index);
	void ClearItem(PARTICLE_INFO_ITEM *item) const;
	void IncreaseArray();
	void Search(SEARCHRESULT *result,const PARTICLE_INFO_ITEM &item) const;
	int BranchBit(const PARTICLE_INFO_ITEM &itemA
		,const PARTICLE_INFO_ITEM &itemB,int startBit) const;

#ifndef NDEBUG
	void DumpArray();
#endif

private:
	//`Ȃ
	ParticleInfoList(const ParticleInfoList &source);
	const ParticleInfoList &operator=(const ParticleInfoList &source);

	Buffer<PARTICLE_INFO_ITEM> m_array;	//z
	int m_bufferCount;	//z̍ő̑傫
	int m_emptyList;	//̗vf̃Xg̐擪
	int m_root;	//T؂̍
#ifndef NDEBUG
	int m_count;
#endif
};

APP_END_NAMESPACE

#endif
