#include "prefix.h"

#include "exception.h"
#include "error.h"

#include <limits.h>

/*************************************************

	I[o[t[mFČvZ

**************************************************/

APP_BEGIN_NAMESPACE

//ʂ̌
static int CheckResult(double result,bool *success)
{
	if(result<INT_MIN ||INT_MAX<result) {
		if(success==NULL) {
			throw Exception(APPERR_INTEGER_OVERFLOW);
		} else {
			*success=false;
		}
		return 0;
	}
	if(success!=NULL) {
		*success=true;
	}
	return static_cast<int>(result);
}

//Z
int SafeAddition(int a,int b,bool *success=NULL)
{
	double result=static_cast<double>(a)+static_cast<double>(b);
	return CheckResult(result,success);
}

//Z
int SafeSubtract(int a,int b,bool *success=NULL)
{
	return SafeAddition(a,-b,success);
}

//|Z
int SafeMultiple(int a,int b,bool *success=NULL)
{
	double result=static_cast<double>(a)*static_cast<double>(b);
	return CheckResult(result,success);
}

APP_END_NAMESPACE
