#include "prefix.h"

#include "spindialog.h"
#include "updatecontrol.h"
#include "showerror.h"
#include "volumecontrol.h"
#include "anglecontrol.h"
#include "spray.h"
#include "spraystyle.h"

#include "resdialog.h"
#include "resstring.h"

/*********************************************

	]̐ݒ̃_CAO

*********************************************/

APP_BEGIN_NAMESPACE

class SpinDialogMember
{
public:
	AngleControl angleControl;
	VolumeControl angleWiggleControl;
	
	double angle;	//]p
	double angleWiggle;	//]p̗h炬
	int step;	//Ԋu
	bool use;	//]邩
};

SpinDialog::SpinDialog()
:Dialog(IDD_SPIN)
,m_m(new SpinDialogMember)
{
}

SpinDialog::~SpinDialog() throw()
{
}

//
void SpinDialog::OnInitDialog()
{
	m_m->angleControl.SubclassDialogItem(
		IDC_SPIN_ANGLE,this);
	m_m->angleWiggleControl.SubclassDialogItem(
		IDC_SPIN_ANGLE_WIGGLE,this);

	m_m->angleWiggleControl.SetRange(
		SprayStyleType(SPRAYSTYLE_SPIN_ANGLE_WIGGLE)->lowerLimit
		,SprayStyleType(SPRAYSTYLE_SPIN_ANGLE_WIGGLE)->upperLimit);

	m_m->angleControl.SetAsRotation(true);
	m_m->angleWiggleControl.SetShowMode(VOLUME_SHOW_DEGREES);

	const SPRAYSTYLE *sprayStyle=GetSprayStyle();
	m_m->use=sprayStyle->useSpin;
	m_m->step=sprayStyle->spinStep;
	m_m->angle=sprayStyle->spinAngle;
	m_m->angleWiggle=sprayStyle->spinAngleWiggle;
}

void SpinDialog::OnCommand(int id,int notifyCode,HWND hwnd)
{
	switch(id) {
	case IDC_SPIN_USE:
		if(notifyCode==BN_CLICKED) {
			UpdateData(UPDATE_VAR);
			UpdateData(UPDATE_CONTROL);
		}
		break;

	default:
		Dialog::OnCommand(id,notifyCode,hwnd);
		break;
	}
}


//Rg[ƕϐ̃f[^\̍XV
void SpinDialog::DataExchange(UpdateControl *updater)
{
	updater->Check(IDC_SPIN_USE,&m_m->use);
	updater->Edit(IDC_SPIN_STEP,&m_m->step);
	updater->Angle(IDC_SPIN_ANGLE,&m_m->angle);
	updater->Volume(IDC_SPIN_ANGLE_WIGGLE,&m_m->angleWiggle);

	updater->Enable(IDC_SPIN_STEP,m_m->use);
	updater->Enable(IDC_SPIN_ANGLE,m_m->use);
	updater->Enable(IDC_SPIN_ANGLE_WIGGLE,m_m->use);
}

//Kp
bool SpinDialog::Apply()
{
	SPRAYSTYLE sprayStyle;
	GetSprayStyle(&sprayStyle);

	int stepLower=SprayStyleType(SPRAYSTYLE_SPIN_STEP)->lowerLimit;
	if(m_m->step<stepLower || sprayStyle.life<m_m->step) {
		ShowError(GetHWND(),IDS_ERR_RANGE_SPIN_STEP,stepLower);
		return false;
	}

	sprayStyle.useSpin=m_m->use;
	sprayStyle.spinStep=m_m->step;
	sprayStyle.spinAngle=m_m->angle;
	sprayStyle.spinAngleWiggle=m_m->angleWiggle;
	SetSprayStyle(sprayStyle);
	return true;
}

APP_END_NAMESPACE
