#include "prefix.h"

#include "spray.h"
#include "tool.h"
#include "registry.h"
#include "string.h"
#include "spraystyle.h"

#include <tchar.h>

/*************************************************

	c[Ƃ̃Xv[̐ݒ

**************************************************/

APP_BEGIN_NAMESPACE

//c[Ƃ̃Xv[̏
static SPRAYSTYLE s_toolSprayStyle[TOOL_COUNT];

static void ExchangeSettings(Registry *registry);

//AvP[V̍ŏ̏
void AppInit_Spray(Registry *registry)
{
	ExchangeSettings(registry);
}

//AvP[VI
void AppSave_Spray(Registry *registry)
{
	ExchangeSettings(registry);
}

//AvP[VI
void AppQuit_Spray() throw()
{

}

void ExchangeSprayStyle(Registry *registry,SPRAYSTYLE *sprayStyle);

//WXgƏ̌
static void ExchangeSettings(Registry *registry)
{
	FOR(int i=0;i<TOOL_COUNT;++i) {
		if(ToolType(i)->useSpray) {
			String subKey;
			subKey.Format(_T("%s\\Spray"),ToolType(i)->name);
			registry->OpenSubKey(subKey.Get());
			ExchangeSprayStyle(registry,&(s_toolSprayStyle[i]));
		}
	}
}

//Xv[̐ݒWXgƌ
void ExchangeSprayStyle(Registry *registry,SPRAYSTYLE *sprayStyle)
{
	SPRAYSTYLE initialStyle;
	InitializeSprayStyle(&initialStyle);

#define EXCHANGE_REGISTRY(a_varName,a2,a_regName,a4,a5,a6,a7,a8)	\
	registry->Exchange(_T(a_regName),&(sprayStyle->a_varName)	\
		,initialStyle.a_varName);

	SPRAYSTYLE_DO_FUNC(EXCHANGE_REGISTRY);

	if(registry->IsReading()) {
		CorrectSprayStyle(sprayStyle);
	}
}

//c[̃Xv[𓾂
const SPRAYSTYLE *GetSprayStyle(int tool)
{
	assert(-1<=tool && tool<TOOL_COUNT);
	if(tool<0) tool=GetTool();
	return &(s_toolSprayStyle[tool]);
}

void GetSprayStyle(SPRAYSTYLE *sprayStyle,int tool)
{
	*sprayStyle=*GetSprayStyle(tool);
}

//c[̃Xv[ݒ肷
void SetSprayStyle(const SPRAYSTYLE &sprayStyle,int tool)
{
	assert(-1<=tool && tool<TOOL_COUNT);
	if(tool<0) tool=GetTool();

	s_toolSprayStyle[tool]=sprayStyle;
	CorrectSprayStyle(&(s_toolSprayStyle[tool]));
}

APP_END_NAMESPACE
