#ifndef APP_STRING_H
#define APP_STRING_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"

#include <windows.h>
#include <stdarg.h>
#include <memory>
#include <tchar.h>

/*************************************************

	NX

**************************************************/

APP_BEGIN_NAMESPACE

class String
{
public:
	String();
	~String() throw();

	String(const String &source);
	String(const char *text);
	String(const wchar_t *text);
	const String &operator=(const String &source);
	const String &operator=(const char *text);
	const String &operator=(const wchar_t *text);

	bool LoadString(int id);
	void Format(const _TCHAR * format,...);
	void Format(int id,...);
	void LoadSystem(DWORD apiErrorCode,...);

	void Alloc(int size);

	bool SingleLine(const String &source,int line=0);

	int Length() const;
	void Shorten();

	int Compare(const _TCHAR * text) const;
	void Cat(const _TCHAR * text);

	void Free() throw();
	bool IsEmpty() const;

	const _TCHAR * Get() const;
	_TCHAR * GetW();

#ifdef _UNICODE
	int MultiByteLength() const;
	void ToMultiByte(char *mbText,int length);

#else
	int UnicodeLength() const;
	void ToUnicode(wchar_t *wcText,int length);
#endif

protected:
	const _TCHAR * StartOfLine(int line) const;

private:
	std::auto_ptr<class StringMember> m_m;
};

void VStringFormat(String *string,const _TCHAR * format,va_list args);

APP_END_NAMESPACE

#endif