#ifndef APP_TOOL_FREEHAND_H
#define APP_TOOL_FREEHAND_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "toolbase.h"

#include <memory>

/*************************************************

	菑̃c[̊{NX

**************************************************/

APP_BEGIN_NAMESPACE

struct EVENT_PARAM;
struct FPOINT;
class Core;
union PA_COLOR;
struct COLOR_INFO;

class ToolFreeHand : public ToolBase
{
public:
	explicit ToolFreeHand(int tool);
	virtual ~ToolFreeHand() throw();

	virtual bool IsCapturing() const;
	virtual bool IsOperating() const;
protected:
	virtual void Event(EVENT_PARAM *eventParam);
	void EventIdle(EVENT_PARAM *eventParam);
	void Start(EVENT_PARAM *eventParam);
	void FirstPut(EVENT_PARAM *eventParam);
	void EventPut(EVENT_PARAM *eventParam);
	void Cancel(EVENT_PARAM *event);
	void Put(EVENT_PARAM *eventParam
		,const FPOINT &point,const FPOINT &throwing,int number);
	void Turn(EVENT_PARAM *eventParam);
	double SprayAngle(int number);
	PA_COLOR RandomColor(const COLOR_INFO &colorInfo) const;
private:
	const std::auto_ptr<class ToolFreeHandMember> m_m;
};

APP_END_NAMESPACE

#endif

