#ifndef APP_VIEW_H
#define APP_VIEW_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "window.h"

/*************************************************

	r[EBhE{NX

**************************************************/

APP_BEGIN_NAMESPACE

class Frame;
class Command;
class Document;

class View : public Window
{
public:
	View();
	virtual ~View() throw();

	void Create(HWND frameWindow);
	virtual LRESULT WindowProc(UINT msg,WPARAM wparam,LPARAM lparam);
	Frame *GetFrame();
	void SetFrame(Frame *frame);
	void AttachDocument(Document *document);
	virtual void OnInitialUpdate()=0;
	virtual bool OnIdle();
protected:
	virtual void OnUpdateCommand(int id,Command *command);
	Document *GetDocument() const { return m_document; }
	void SetScrollSize(SIZE size);
	void OnHScroll(int scrollCode,short int pos,HWND bar);
	void OnVScroll(int scrollCode,short int pos,HWND bar);
	void OnScroll(int scrollCode,short int pos,int bar);
	virtual void OnSize(UINT type,int width,int height);
	void OnSizeSub(int bar,int clientSize,int scrollSize);
	POINT GetScrollPos() const;
	int GetScrollPosSub(int bar,int clientSize,int scrollSize) const;
	void OnPrepareDC(HDC hDC);
	void SetStatusText(int textID);
	virtual void OnFileClose();
private:
	//`Ȃ
	View(const View &source);
	const View &operator=(const View &source);

	Frame *m_frame;	//t[EBhEIuWFNg
	Document *m_document;	//LĂ镶IuWFNg
	SIZE m_scrollSize;	//XN[
};

APP_END_NAMESPACE

#endif

