#! /bin/perl

# It changes version number and last modified year.

$newversion='0.3';
$newversion2='0,3,0,0';
$newyear='2004';

@textlist = ('README.ja.txt','README.en.txt','help/ja/index.html','help/en/index.html');
foreach $file (@textlist) {
	&change_text_file($file);
}

@packbatlist = ('pack_ja.bat','pack_en.bat','pack_src.bat');
foreach $file (@packbatlist) {
	&change_packbat_file($file);
}

&change_rc_file('source/painticle.rc');



sub change_string
{
	local($filename)=$_[0];
	local($backup)="$filename.bak";

	unlink($backup);
	rename($filename,$backup) || die("Can't rename $filename to $backup");

	unless(open(FILEREAD,$backup)&&open(FILEWRITE,"> $filename")) {
		rename($backup,$filename);
		die "Can't open $backup";
	}

	local($exp1)=$_[1];
	local($new1)=$_[2];
	local($exp2)=$_[3];
	local($new2)=$_[4];
	local($exp3)=$_[5];
	local($new3)=$_[6];

	while(<FILEREAD>) {
		local($old) = $_;
		s/$exp1/$new1/ if(defined($exp1));
		s/$exp2/$new2/ if(defined($exp2));
		s/$exp3/$new3/ if(defined($exp3));

		print FILEWRITE $_;
		print ("$filename $.: $old --> $_") if($_ ne $old);
	}

	close(FILEWRITE);
	close(FILEREAD);
}

sub change_text_file
{
	&change_string($_[0],'Painticle\s+version\s*[.\d]+',"Painticle version $newversion"
		,'Copyright\s*\(C\)\s*\d+\sUsinosizuku',"Copyright (C) $newyear Usinosizuku");
}

sub change_packbat_file
{
	&change_string($_[0],'SET\s+~VERSION=[.\d]+',"SET ~VERSION=$newversion");
}

sub change_rc_file
{
	&change_string($_[0],'#define\s+APP_VERSION\s+"[.\d]+"',"#define APP_VERSION \"$newversion\""
		,'#define\s+APP_VERSION2\s+\d,\d,\d,\d',"#define APP_VERSION2 $newversion2"
		,'#define\s+LAST_MODIFIED_YEAR\s+"\d+"',"#define LAST_MODIFIED_YEAR \"$newyear\"");
}
